#include "clientprot.h"

//////// Client handlers ////////

void addZone(serverEntry * se);

void handleServerListResponse(hostMessage * msg)
{
	Uint32 i = 1;
	serverEntry * se = new serverEntry();
	Uint32 len;

	while (i + 79 < msg->len)
	{
		// Extract entry
		se->ip = getLong(msg->msg, i);
		se->port = getShort(msg->msg, i + 4);
		se->population = getShort(msg->msg, i + 6);
		se->scoring = getShort(msg->msg, i + 8);
		se->version = getLong(msg->msg, i + 10);

		i += 14;
		MEMCPY(msg->msg + i, se->name, 64);

		i += 64;
		len = strlen(msg->msg + i) + 1;
		MEMCPY(msg->msg + i, se->comment, len);
		i += len;

		addZone(se);
	}

	msg->src->disconnect(true);

	printf("---Download complete\n");

	delete se;
}
